/**
 * server - file server in UDP protocol.
 * 2000-2001 by AUTHORS (see AUTHORS for more informations).
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of the
 * gnu/poker distribution for more details.
 *
 * ls.c :  functions used to design the 'ls'.
 * 
 * dim nov 25 10:50:21 CET 2001 - c.lucas  - first edition
 *
 */
#include "client.h"
#include "common.h"
#include "../lib/ftp.h"

/*
 * This functions is the implementation of 'remote ls'.
 */
int ls2( int fd , struct sockaddr_in *s , size_t s_s )
{
	packet		p ;
	int		retval , lg , nb_chunk , nb_packet ;

	if( connected != 1) {
		printf("Not Connected.\n");
		return -1;
	} 

	/* initialisation de certaines variables */
	lg = sizeof( struct sockaddr_in );
	retval = -1 ;
		
	while( retval == -1) {
		p.header = CTRL_PACKET ;
		p.type_packet.control.ordre = LS ;
		if( (retval = resend( fd , &p , sizeof(packet) , ACK_LS ,
				(struct sockaddr *)s , sizeof(struct sockaddr) )) <= 0 ) {
			switch( retval) {
				case 0:
					nb_chunk = p.type_packet.control.gen_num ;
				break;
	
				case -BEGIN_DATA: retval = -1; 
				break;
				default:
					return retval;
			}/* switch */
		}/* if */
	}/* while */

	bzero( &p , sizeof(p) );
	/* we are waiting for the nb_chunk */
	retval = my_read( fd , &p , sizeof(p) , (struct sockaddr *)s , &lg ) ;
	if( retval < 0 ) {
		fprintf(stderr,"lowserver> get> my_read\n");
		return -1;
	} else {
		switch( retval ) {
			case BEGIN_DATA: {		
		 		/* we send the acknowledge message */
				bzero( &p , sizeof(packet) );
				p.header = CTRL_PACKET ;
				p.type_packet.control.ordre = ACK_BEGIN_DATA ;
				sendto( fd , &p , sizeof(packet),0,(struct sockaddr *)s,sizeof(struct sockaddr) ); 
				/* we keep this information */
				nb_packet = p.type_packet.control.gen_num ;
			}
			break;
			
			default:
				fprintf(stderr,"lowserver>> ls2> ls_data> wrong message receive from server ( is he dumb ?!!)\n");
				return -1;
		}
	}

	ls_data( fd , s , nb_chunk , nb_packet );
return 0;
}

/**
 * ls_data:
 *
 * parameter(s):
 * o	fd : descriptor of socket
 * o	file : filename to get
 * return:
 * o	int
 */
int ls_data( int fd , struct sockaddr_in *s , int nb_chunk , int nb_packet )
{
	packet		p;
	int		retval , lg;
	int		tmp_chunk , tmp_packet , fd_file ;
	int 		chunk_length , num , current_chunk , donnees , i, transfert_state ;
	data_block	*tab = NULL ;

	/* initialisation de certaines variables */
	lg = sizeof( struct sockaddr_in );
	donnees = i = chunk_length = 0;

	tab = create_tab( );		
	
/* 
 * FIXME:
 * This part of code is awfull: i know !!
 * If i have more time i'll code this in a better way !
 */

	while( donnees == 0  ) {
		/*
		 *	C'EST JUSTE POUR UN TEST !!!
	 	 */
		bzero( &p , sizeof(packet) );
		retval = titux_read( fd , &p , sizeof(p) , (struct sockaddr *)s , &lg ) ;
		switch( retval ){
			case CTRL_PACKET: {
				switch( p.type_packet.control.ordre ) {
					case END_CHUNK : {
						if( chunk_length == i ) {
							i = 0 ;
							/* all packets of this chunk are received */
							fflush_tab_stdout( fd_file , tab , chunk_length );
							/* we init tab for further chunk */
							init_data_tab( tab );
							/* we send a CHUNK_OK message */
							p.header = CTRL_PACKET ; 
							p.type_packet.control.ordre = CHUNK_OK ;
							sendto( fd , &p , sizeof(packet),0,(struct sockaddr *)s,sizeof(struct sockaddr) ); 

							if( current_chunk == nb_chunk )
								transfert_state = 1 ;

						} else {
							/* some packets have bee losen */
							p=update_ctrl_msg_list( tab , chunk_length);
							sendto( fd , &p , sizeof(packet),0,(struct sockaddr *)s,
											sizeof(struct sockaddr) ); 
						}		
					}
					break;
		
					case END_GET: {
						/* this is the end ! ;) */
						donnees = 1 ;
						if( transfert_state != 1 ) {
							/* 
							 * we reached the end of transfert without all data:
							 * OUCH !!!! ;-(
							 */
							fprintf(stderr,"ls> ls_data> Error in transfert !\n");
							return -1;
						} else {
							unsigned int 		taille ;
							taille       =  p.type_packet.control.gen_num ;
							printf("\n>> %d bytes send.\n",taille);
						}
					}
					break;	
					default: fprintf(stderr,"ls> ls_data> I don't"
							 "understand what he said!(%d)\n",p.type_packet.control.ordre);
				} /* switch */
			}
			break ;
			case DATA_PACKET: {
				switch( p.type_packet.donnees.ordre ) {
					case BEGIN_CHUNK: {
						int size ;
						num = p.type_packet.donnees.num_packet ;
						chunk_length = p.type_packet.donnees.chunk_length ;
						current_chunk = p.type_packet.donnees.num_chunk ;
						tab[ num ].length = size = p.type_packet.donnees.packet_size ;
						tab[ num ].ok = 1 ;
						memcpy( tab[ num ].data , p.type_packet.donnees.data , size ); 
						/* i++: sert uniquement pour savoir le nb de paquets recus. */
						i++;
					}
					break;

					default:
						fprintf(stderr,"ls> ls_data> Problem: message ununderstood !\n");
						return -1 ;
				
				}/* switch */	
			}
			break;
			case -1 : {
				fprintf(stderr,"ls> ls_data> titux_read => Error with the server !\n");
				return -1; 
			}
			break;
			default:
		}/* switch */
	}/*while*/

	free( tab );
return 0;
}

/**
 * fflush_tab_stdout:
 * this function fflush array ob block on standard output
 * parameter(s):
 * o fd_file : file descriptor
 * o tab : array of block
 * o num_packet : number of packet in the array
 * return:
 * void function
 */
void fflush_tab_stdout( int fd_file , data_block *tab , int num_packet )
{
	register int 		i;
	
	for( i=0 ; i<num_packet ; i++ ){
		write( 1 , tab[i].data , tab[i].length );
	}
}

/*
 * This functions is the implementation of 'remote ls'.
 * It was the first implementation: just for history !! :)
 */
int ls( int fd , struct sockaddr_in *s , size_t s_s )
{
	packet		p ;
	int 		retval , ok , donnees , i , nb;
	bloc_ls		*tab = NULL ;

	if( connected != 1) {
		printf("Not Connected.\n");
		return -1;
	} 


	ok = 0 ;
	/* we start:*/
	send_ls( fd , &p , sizeof(p) );
	/* waitin for an ACK */
	retval = my_read( fd , &p , sizeof(p) , (struct sockaddr *)s , &s_s ) ;
	if( retval < 0 ){
		/* server doesn't respond in time */
		printf("ls>read_packet> server doesn't respond\n");
		
	} else {
		if( p.type_packet.control.ordre == ACK_LS ) {
			nb = p.type_packet.control.gen_num ;
			tab = create_tab_block_ls( nb );	
			sendto( fd , &p , sizeof(packet),0,(struct sockaddr *)s,sizeof(struct sockaddr) ); 
		} else {
			printf("j'ai recu un paquet que je ne comprends pas:%d\n",p.type_packet.control.ordre);
		}
	}
	i = 0 ;
	while( ok == 0 ) {	
		donnees = 0;
		while( donnees == 0  ) {
			retval = my_read( fd , &p , sizeof(p) , (struct sockaddr *)s , &s_s ) ;

			if( retval < 0 ){
				/* server doesn't respond in time */
				printf("ls>read_packet> server doesn't respond\n");
			
			} else {
				if( p.type_packet.control.ordre == DATA_LS ) {
					int num ;

					num = p.type_packet.control.gen_num ;
					tab[ num ].ok = 1 ;
					memcpy( tab[ num ].ligne_ls , p.type_packet.control.liste , NB_PACKET_TO_SEND*sizeof(char) ); 
					/* i++: sert uniquement pour savoir le nb de paquets recus. */
					i++;
				} else {
					donnees = 1 ;
				}	
			}
		}/*while*/



		if( p.type_packet.control.ordre == END_LS ) {
			p.type_packet.control.ordre = ACK_END_LS ;
			sendto( fd , &p , sizeof(packet),0,(struct sockaddr *)s,sizeof(struct sockaddr) ); 

			if( i == nb ) {
				p.type_packet.control.ordre = LS_OK ;
				sendto( fd , &p , sizeof(packet),0,(struct sockaddr *)s,sizeof(struct sockaddr) ); 
				for( i=0 ; i<nb ; i++ ) {
					print_ls_block( tab, i ) ;	
				}
				ok = 1 ;
			} else {
				int j, k ;

				k=0;
				p.type_packet.control.ordre = LS_NOT_OK ;
				for( j=0 ; j<nb ; j++ ) {
					if( tab[i].ok == -1 ) {
						p.type_packet.control.liste[k]= 0 ;
					} else {
						p.type_packet.control.liste[k]= 1 ;
					}	
				}/*for*/
				sendto( fd , &p , sizeof(packet),0,(struct sockaddr *)s,sizeof(struct sockaddr) ); 
			}/*if*/
		}/*if*/
	}/*while*/
return 0;
}

/*
 * send_ls:
 * This function send a 'ls' command to the server
 * parameters:
 * o	fd : socket descriptor
 * o	p : pointer on a packet variable
 * o	s : size of 'p'
 */
void send_ls( int fd , packet *p , size_t s )
{
	p->header = CTRL_PACKET ;
	p->type_packet.control.ordre = LS ;
	send( fd , p , s , 0 ) ;
}


/*
 * print_ls_packet:
 * print on standard output data of ls in packet.
 * parameters:
 * o	p : pointer on a packet variable
 */
void print_ls_block( bloc_ls *t , int i)
{
	char		*ptr = NULL ;
	
	ptr = strtok( t[i].ligne_ls , ":" );
	printf("%s\n",ptr );
	while( (ptr = strtok( NULL , ":" )) != NULL ) {
		printf("%s\n",ptr );
	}
}

/*
 * create_tab_block_ls:
 * This function create a array of block for 'ls'
 * parameters:
 *
 * return:
 *
 */
bloc_ls* create_tab_block_ls( int nb )
{
	bloc_ls		*tmp = NULL ;
	int		i , lg ;

	tmp = (bloc_ls *) malloc( sizeof(bloc_ls) * nb );
	if( tmp == NULL ) {
		perror("my_ftp>> create_tab_block_ls> malloc");
		exit(1);
	}

	/* length of string is constant */
	lg = NB_PACKET_TO_SEND * sizeof(char) ;

	for( i=0 ;i<nb ; i++ ) {
		tmp[i].ok = -1 ;
		bzero( tmp[i].ligne_ls , lg );
	}

return tmp ;
}


