/**
 * server - file server in UDP protocol.
 * 2000-2001 by AUTHORS (see AUTHORS for more informations).
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of the
 * gnu/poker distribution for more details.
 *
 * main.c :  service de ftp
 * 
 * v 0.0.1 - 30/04/01 - christophe, lucas  - first edition
 *
 */
#include "packet.h"
#include "csock.h"
#include "client.h"

int 		fdsock ;
short		connected ;

int main( int argc , char **argv )
{
	struct sockaddr_in	sin , from  ;
	struct stat		s ;
	socklen_t		s_sin , s_from ;
	int			i, fd , taille , retval , choix , nb_arg ;
	packet			p ;
	char			buffer[100];
	char			my_prompt[100];
	char			**arg = NULL; 
	

	strcpy( my_prompt , "\nmy_ftp>");
	splash_screen( );

	nb_arg = 0 ;

	while( 1 ) {
		printf("%s",my_prompt); fflush( stdout );
		memset( buffer , 0 , sizeof(buffer) );
		if( fgets( buffer , sizeof( buffer ) , stdin ) == NULL ) {
			perror("fgets");
			exit(2);
		}

		i = strlen( buffer ) - 1 ;
		while( i >= 0 ) {
			if( buffer[i] = '\n' ){
				buffer[i] = '\0' ;
				i = -1 ;
			}
		} 

		/* we free the space used by the char** array */
		if( arg != NULL ) { 
			for( i=0 ; i<nb_arg ; i++ )
				free( arg[i] );
	
			free( arg );
		}

		arg = read_prompt( buffer , &choix , &nb_arg);
		if( arg != NULL )
		switch( choix ) {
			case 1: {
				struct hostent		*he ;
				struct sockaddr_in 	A ;	

				if( nb_arg != 2 ) {
					printf("client socket [%s,%s] created...",arg[1],arg[2]);
					fflush( stdout );
					fdsock = client_socket( arg[1] , arg[2] , "udp" );
					if( fdsock > 0 ) {
						printf("ok\n");
					} else {
						printf("failed");
						exit(2);
					}
	
					p.header = CTRL_PACKET ;
					p.type_packet.control.ordre = CONNECT ;
	
					he = gethostbyname( arg[1] );
					A.sin_family = AF_INET ;
					A.sin_port = htons( atoi( arg[2] ) );
					memcpy(&A.sin_addr , he->h_addr , he->h_length );


					sendto( fdsock , &p , sizeof(packet) , 0 , (struct sockaddr *)&A , sizeof(struct sockaddr)  );

					retval = my_read( fdsock , &p , sizeof(p) , (struct sockaddr*)&from , &s_from ); 
					if( p.type_packet.control.ordre == ACK ){ 
						printf("connected to server..\n");
						A.sin_port = htons( p.type_packet.control.gen_num);
						connect( fdsock , (struct sockaddr* ) &A , sizeof(A) ) ; 
						printf("moving port to %d...\n", p.type_packet.control.gen_num);
						sin = A ;
						strcpy( my_prompt , "\n\nmy_ftp");
						strcat( my_prompt , "[" );
						strcat( my_prompt , p.type_packet.control.liste );	
						strcat( my_prompt , "]> " );
			
						connected = 1 ;
					} else {
						printf("no response from the server.\n");
					}
				} else 
					printf("You have forgotten something !?!\nUsage:\topen [host] [port]\n");
				}/* bloc du case */
				break;

			case 2: {
					if( connected == 1 ) 
						get( fdsock , arg[1] , &sin );
					else
						printf("Not connected.\n");
						
				}
				break;

			case 3:	if( connected == 1 ) {
					printf("arg[1]=<%s>\n",arg[1]);
					client_send( fdsock , &sin , arg[1] , my_prompt );
				}
				else
					printf("Not connected.\n");
				break;
	
			case 4: if( connected == 1 ) {
					/* ls( fdsock , &sin , sizeof(sin) ); */
					ls2( fdsock , &sin , sizeof(sin) ); 
				} else {
					printf("Not connected.\n");
				}
				break;
	
			case 5: {
				int 		retval ;
				char		buffer[100];

					if( connected == 1 ) {
						retval = my_chdir( fdsock , &sin , arg[1] , my_prompt);
					} else {
						printf("Not connected.\n");
					}
				}
				break;

			case 6: print_help( ); 
				break;

			case 7: {
					if( connected == 1) {
						p.header = CTRL_PACKET ;
						p.type_packet.control.ordre = END_SESSION ;
						sendto( fdsock , &p , sizeof(packet) , 0 , (struct sockaddr *)&sin , sizeof(struct sockaddr) );
						printf("exiting...\n");
						close( fdsock );
						exit(0);
					} else { printf("exiting...\n");exit(0); }
				}
				break;

			default:
				printf("Undefined command\n");
		}/*switch*/	
		
	}

	/* never reached */
	printf("socket serveur close...ok\n");
	close( fdsock );

return 0 ;
}
