/**
 * myftp - my ftp service in UDP mode.
 * 2000-2001 by AUTHORS (see AUTHORS for more informations).
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of the
 * gnu/poker distribution for more details.
 *
 * utils.c : functions for the prompt
 * 
 * sam nov 10 11:38:36 CET 2001 - clucas - first edition
 *
 */


#include "client.h"

/**
 * read_prompt:
 * This function read the standard input and reat on.
 * parameter(s):
 * o char*	: the ligne
 * o int * 	: the number of the choice
 * o int *	: the number of argument
 * return:
 * o char **	: array of argument
 */
char** read_prompt( char *prompt, int *choix, int *nb_arg)
{
	char 		**temp = NULL ;
	char		*token ;
	int 		retval , taille_tab_pointeur , taille_champ , i , main_cmd;

	retval = main_cmd = -1 ;
	i = 0 ;

//	printf("prompt=<%s>",prompt); fflush( stdout );

	token = strtok( prompt , " " );
	if( token == NULL )
		return NULL ;
	else {
		if( strcmp( token , "open" ) == 0)
			retval = main_cmd = 1;
	
		if( strcmp( token , "get" ) == 0 )	
			retval = main_cmd = 2;
	
		if( strcmp( token , "send") == 0)
		retval = main_cmd = 3;
   
		if( strcmp( token , "ls" ) == 0 )
			retval = main_cmd = 4;
	
		if( strcmp( token , "cd" ) == 0 )
			retval = main_cmd = 5;
	
		if( strcmp( token , "help") == 0 )
			retval = main_cmd = 6;

		if( strcmp( token , "quit" ) == 0 )
			retval = main_cmd = 7;	
	}

	taille_tab_pointeur = (i+1)*sizeof(char);
	taille_champ = strlen( token )+1 ;


	if((temp=(char**)malloc(taille_tab_pointeur))==NULL||(temp[i]=(char*)malloc(taille_champ))==NULL) {
		perror("myftp> read_prompt: realloc or malloc");
		exit(1);
	}
	strcpy( temp[i] , token );
	i++;

	while( (token=strtok( NULL , " " )) != NULL ) {

		taille_tab_pointeur = (i+1)*sizeof(char*);
		taille_champ = strlen( token )+1 ;

		if((temp=(char **)realloc(temp,taille_tab_pointeur))==NULL||(temp[i]=(char*)malloc(taille_champ))==NULL) {
			perror("myftp> read_prompt: realloc or malloc");
			exit(1);
		}
		
		strcpy( temp[i] , token );
	
		i++ ;
	}

//	temp[i+1] = NULL ;
	*nb_arg = i;
	*choix  = retval ;

return temp ;
}



/**
 * splash_screen:
 *
 * parameter(s):
 *
 * return:
 *
 */
void splash_screen()
{
//	printf("\033[2J");
	
	printf("*************************************************************************\n");
	printf("*** Universit de Rouen             -               Maitrise GMI      ***\n");
	printf("*** ----------------------------------------------------------------- ***\n");
	printf("*** myftp client v0.1.8 - LUCAS Christophe - c.lucas@ifrance.com      ***\n");
	printf("*************************************************************************\n");
	printf("\n\t1 - Open a myftp_server (open).");
	printf("\n\t2 - Get file from server (get).");
	printf("\n\t3 - Send file to server (send).");
	printf("\n\t4 - list files on server (ls).");
	printf("\n\t5 - change current directory (cd).");
	printf("\n\t6 - some help (help).");
	printf("\n\t7 - To quit(quit).");

}

/**
 * print_help:
 *
 * parameter(s):
 *
 * return:
 *
 */
void print_help()
{
 	printf("\n\t1 - Open a myftp_server (open).");
	printf("\n\t2 - Get file from server (get).");
  	printf("\n\t3 - Send file to server (send).");
  	printf("\n\t4 - list files on server (ls).");
  	printf("\n\t5 - change current directory (cd).");
 	printf("\n\t6 - some help (help).");
	printf("\n\t7 - To quit(quit).");
} 
