/**
 * libcsock - library for managed UNIX socket implementation
 * 1999-2000 by Christophe Lucas <c.lucas@ifrance.com>
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of the
 * libcsock distribution for more details.
 *
 * csock.h
 * 
 * v 0.0.1 - 23/07/00 - christophe, lucas  - premire dition
 * v 0.0.2 - 24/04/01 - christophe, lucas  - rvision
 * v 0.0.3 - 30/04/01 - c.lucas && a.pique - added write_n and read_n
 *
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
/* si l'on devait porter tout cela => certains headers devraient
 * tre en #ifdefined ...
 */

#ifndef INADDR_NONE
#define INADDR_NONE	0xffffffff
#endif

void error_socket( const char* format , ... );
int creat_socket( const char* service , const char* transport , struct sockaddr_in* sin );
int client_socket( const char* host , const char* service , const char* transport );
int server_socket( const char* service , const char* transport , int lqueue );
int accepter( int fd , struct sockaddr_in* fd_sock);
int write_n(register int fd , void *p , int nb);
int read_n(register int fd , void *p , int nb);

