/**
 * myftp - my ftp service in UDP mode.
 * 2000-2001 by AUTHORS (see AUTHORS for more informations).
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of the
 * gnu/poker distribution for more details.
 *
 * packet.h : define the structure of packets
 * 
 * sam nov 10 11:30:36 CET 2001 - clucas - first edition
 * Sun Dec  2 21:50:46 CET 2001 - clucas - maj pour ls
 * ven jan 18 22:32:04 CET 2002 - clucas - lot of change this last version...
 *
 */
#ifndef packet_h
#define packet_h

/* --------------- Section :  Headers ---------------------------------- */
#include <math.h>

/* --------------- Section :  #define ---------------------------------- */ 
#define CTRL_PACKET		1
#define DATA_PACKET		2

#define	DATA_SIZE		1020
#define PACKET_PER_CHUNK	255
#define CTRL_TAILLE_FIC		100	

#define NB_PACKET_TO_SEND	255

/* commands */
#define ACK			200
#define CONNECT			201
#define BEGIN			202
#define END			203
#define	LS			204
#define DATA_LS			205
#define ACK_LS			206
#define ACK_END_LS		207
#define	END_LS			208
#define LS_OK			209
#define LS_NOT_OK		210
#define END_SESSION		211
#define	CHDIR			212
#define CHDIR_OK		213
#define CHDIR_PERMISSION_DENIED 214
#define CHDIR_PATH_NOT_FOUND	215
#define GET			216
#define SEND			217
#define BEGIN_GET		219
#define	ACK_BEGIN_GET		220
#define	BEGIN_DATA		221
#define	ACK_BEGIN_DATA		222
#define BEGIN_CHUNK		223
#define END_CHUNK		224
#define CHUNK_OK		225
#define CHUNK_NOT_OK		226
#define END_GET			227
#define ACK_END_GET		228
#define FILE_NOT_FOUND		229
#define	FILE_OK			230
#define ERR_FILE_IS_DIR		231
#define ERR_FILE_IS_LINK	232
#define ERR_FILE_IS_SOCKET	233
#define ERR_NO_SPACE		234
#define FILE_TOO_LARGE		235
#define	ACK_SEND		236
#define PERMISSION_DENIED	237
#define CHDIR_ERROR		238

/* --------------- Section : Variables globales ------------------------ */

/* --------------- Section : Def structures ---------------------------- */
typedef struct ctrl {
	short 		ordre ;				/* l'ordre a pass client ET serveur */
	long		gen_num ;			/* generic number: means size and number */
	char		liste[NB_PACKET_TO_SEND];	/* la liste des paquets  renvoyer */
} ctrl ;

typedef struct data {
	short		ordre;				/* l'ordre a pass client ET serveur */
	long		num_packet ;			/* numro du paquet */
	long		num_chunk ;			/* numero du chunk */
	int		chunk_length ;			/* nb paquets dans ce chunk */
	int		packet_size ;			/* longueur en octet du paquet */
	char		data[DATA_SIZE];		/* donnes */
} data ; 

typedef struct a {
	unsigned int 	header ;
	int 		id ;				/* le serveur nous attribut une id */
	union u {
		ctrl	control ;
		data	donnees ;	
	} type_packet ;
} packet ;

/* -- bloc_ls -- */
typedef struct _bloc_ls{
	short ok ;
	char ligne_ls[NB_PACKET_TO_SEND] ;
} bloc_ls ;

/* -- data_bloc -- */
typedef struct _data_block{
	short 		ok;
	unsigned int 	length;
	char		data[DATA_SIZE];
} data_block ;

/* --------------- Section : Prototype de fonctions -------------------- */

/* --------------- Section : Notes Techniques -------------------------- */
#endif
