/**
 * server - file server in UDP protocol.
 * 2000-2001 by AUTHORS (see AUTHORS for more informations).
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of the
 * gnu/poker distribution for more details.
 *
 * sys.c :  upper level write and read.
 * 
 * jeu nov 15 21:56:20 CET 2001 - clucas - first edition
 * jeu dc 27 19:39:16 CET 2001 - clucas - add to resend negativ return of type msg
 * dim jan 20 15:22:47 CET 2002 - clucas - some bug fixes => stable version.
 *
 */

#include "server.h"
#include "packet.h"
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <dirent.h>

extern int		errno ;

/*
 * my_read:
 * Cette fonction a pour but d'envoyer de faon sure un message au client.
 * parametres:
 * o fd         : socket descriptor
 * o p          : packet
 * o s_packet   : size of packet
 * o msg_waited : type of message what we wait for
 * o s          : structure information socket
 * o s_s        : size of structure information socket
 * return:
 * 0 if msg received, -1 else
 */
int my_read( int fd , packet *p , size_t s_packet , struct sockaddr *s , size_t *s_s )
{
	int			retval , cpt , size;
	struct timeval		t ;	
        fd_set			rfds;
	packet 			temp ;

	cpt = 0 ;

	size = sizeof( struct sockaddr );        

/*
 * dim jan 20 15:11:00 CET 2002
 * VALEURS QUI MARCHENT:
 * bcle = 20 
 * tv_sec=0;
 * tv_usec=5;
 */
	while( cpt < 20 ) {
	       	do {
			FD_ZERO(&rfds);
		        FD_SET(fd , &rfds);
       			/* Pendant 5 secondes maxi */
       		 	t.tv_sec = 0;
       	 		t.tv_usec = 500;

			retval = select(fd+1, &rfds, NULL, NULL, &t);
		} while( (retval < 0) && (errno == EINTR) ) ; 
		/* pour empecher de sortir sur une interruption */

        	if ( retval > 0 ) {
			bzero( p , sizeof(p) );
			if( recvfrom( fd , p , sizeof(packet) , 0 , (struct sockaddr*)s , &size ) > 0 ) {
				return p->type_packet.control.ordre ;
			} 
		}
		cpt ++ ;
	}
return -1 ;	
}

/*
 * resend:
 * Cette fonction a pour but d'envoyer de faon sure un message au client.
 * parametres:
 * o fd         : socket descriptor
 * o p          : packet
 * o s_packet   : size of packet
 * o msg_waited : type of message what we wait for
 * o s          : structure information socket
 * o s_s        : size of structure information socket
 * return:
 * 0 if msg received, -1 else
 */
int resend( int fd , packet *p , size_t s_packet , int msg_waited , struct sockaddr_in *s , size_t *s_s )
{
	int 		i , retval , lg ; 
	packet 		temp ;
	
	struct sockaddr_in a;

	lg = sizeof( struct sockaddr );
	i = 0 ; 
	temp = *p;
	while( i < 20 ) {
		if( sendto( fd , &temp , sizeof(packet) , 0 , (struct sockaddr *)s , sizeof(struct sockaddr_in) ) < 0 ) {
			perror("lowserver>> resend> sendto");
			exit(1);
		}
	
		bzero( p , sizeof(p) );
		retval = my_read( fd , p , sizeof(packet) , (struct sockaddr *)s , &lg);
		switch( retval ) {
			case -1: { }
				break;

			default: 
				if( p->type_packet.control.ordre == msg_waited ) {
					return 0;
				} else {
					return -( p->type_packet.control.ordre );
				}
				break;
		}/*switch*/
	i++;
	}	
printf("no response from remote client since 20*myread_time\n");
return -1 ;	
}

/**
 * kill_lowserver:
 * this function must kill the lowserver and warn the server.
 * parameter(s):
 * none
 * return:
 * this a void function
 */
void kill_lowserver( )
{
	printf("lowserver> exiting...\n");
	/* je prviens mon pre que je me suicide */
	kill( getppid() , SIGUSR1 ); 
	exit(0);
}

/**
 * titux_read:
 * this function has for goal to read a packet and
 * to filter some packet.
 * parameter(s):
 * o fd		: file descriptor
 * o p		: packet
 * o s_packet	: size of the packet
 * o s		: structure sock
 * o s_s	: size of structure s
 * return
 * int		: kind of packet
 *
 */
int titux_read( int fd , packet *p , size_t s_packet , struct sockaddr *s , size_t *s_s )
{
	int		retval ;

	retval = my_read( fd , p , s_packet , s , s_s );
	if( retval > 0 ) {
		if( p->header == CTRL_PACKET )
			return CTRL_PACKET ; 
		else {
			if( p->header == DATA_PACKET )
				return DATA_PACKET ;
			else {
				return -1 ;
			}
		}
	} else {
		return 0;
	}
}
