/**
 * server - file server in UDP protocol.
 * 2000-2001 by AUTHORS (see AUTHORS for more informations).
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of the
 * gnu/poker distribution for more details.
 *****************************************************************************
 * chdir.c :  core of remote-chdir implementation
 *****************************************************************************
 * lun dc 24 17:16:34 CET 2001 - clucas  - first edition
 *****************************************************************************
 */
#include "common.h"
#include "server.h"

void my_chdir( int fd , struct sockaddr_in *s, const char *path )
{
	packet		p;

	if( chdir( path ) == -1 ) {
		switch( errno ) {
			case EACCES :
				p.header = CTRL_PACKET ;
				p.type_packet.control.ordre =	CHDIR_PERMISSION_DENIED ;
				sendto( low_fdsock , &p , sizeof(packet) , 0 , (struct sockaddr *)s , sizeof( struct sockaddr_in ));	
			break;
			case ENOENT :
				p.header = CTRL_PACKET ;
				p.type_packet.control.ordre =	CHDIR_PATH_NOT_FOUND;
				sendto( low_fdsock , &p , sizeof(packet) , 0 , (struct sockaddr *)s , sizeof( struct sockaddr_in ));	
			break;
			default:
				p.header = CTRL_PACKET ;
				p.type_packet.control.ordre =	CHDIR_ERROR;
				sendto( low_fdsock , &p , sizeof(packet) , 0 , (struct sockaddr *)s , sizeof( struct sockaddr_in ));
		}
	} else {
		p.header = CTRL_PACKET ;
		p.type_packet.control.ordre = CHDIR_OK ;
		getcwd( p.type_packet.control.liste , NB_PACKET_TO_SEND*sizeof(char) );
		sendto( low_fdsock , &p , sizeof(packet) , 0 , (struct sockaddr *)s , sizeof( struct sockaddr_in ));	
	}
}
