/**
 * server - file server in UDP protocol.
 * 2000-2001 by AUTHORS (see AUTHORS for more informations).
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of the
 * gnu/poker distribution for more details.
 ***************************************************************************
 * main.c :  ftp service
 ***************************************************************************
 * dim jan 20 22:14:00 CET 2002 - clucas - stable version
 ***************************************************************************
 */
#include "packet.h"
#include "csock.h"
#include "server.h"
//#include "commun.h"

int 			fdsock, low_fdsock ,nb_connecte , taille_fic , nb_packet_to_receive, id ;
data			tab_packet[NB_PACKET_TO_SEND];
struct sockaddr_in	ssin , from ;
socklen_t		s_sin , s_from ;
int			*tab_proc = NULL ;
int			nb_lowserver ,nb_temp_port ;


int main( int argc , char **argv )
{
	char			buffer[255];
	char			path[255];
	char			port[10];
	char			file[255];
	packet			p ;
	int			cpt_p , retval , ret_read ;
	static struct sigaction	action ;
	FILE			*fd;
	char			*pt ;

	nb_lowserver = 0 ;
	nb_temp_port = 3000 ;	/* start number port */

	printf("handler installed...");
	action.sa_handler = hd ;
	retval = sigaction( SIGINT , &action , NULL );
	action.sa_handler = hdusr1 ;
	retval = sigaction( SIGUSR1 , &action , NULL );
	
	if( !retval ) {
		printf("ok.\n");
	} else {
		printf("failed.\n");
	}

	if( argc == 2 ) {
		/* fichier pass en paramtre */
		if( retval = test_file( argv[1] ) > 0 ) {
			fd = fopen( argv[1] , "r" );
			if( fd == NULL ) {
				perror("server> open config file");
				exit(1);
			}	
			pt = fgets( port , 255 , fd );
			if( pt == NULL ){
				perror("server> fgets (port)");
				exit(2);
			}
			pt = fgets( path , 255 , fd );
			if( pt == NULL ){
				perror("server> fgets (path)");
				exit(2);
			}
			strncpy( file , argv[1] , 255 );
			fclose( fd );
			port[ strlen(port) - 1 ] = '\0';
			path[ strlen(path) - 1 ] = '\0';
			chdir( path );
		} else {
			printf("No configure file %s, we use standard values.\n",argv[1]);
			/* on utilise les paramtres standards */
			strncpy( port , "2222" , 10 );
			strncpy( file , "[default settings]" , 255 );
			getcwd( path , 255 );	
		}

	} else {
		/* fichier standard */
		if( retval = test_file( "server.conf" ) > 0 ) {
			fd = fopen( "server.conf" , "r" );
			if( fd == NULL ) {
				perror("server> open config file");
				exit(1);
			}	
			pt = fgets( port , 255 , fd );
			if( pt == NULL ){
				perror("server> fgets (port)");
				exit(2);
			}
			pt = fgets( path , 255 , fd );
			if( pt == NULL ){
				perror("server> fgets (path)");
				exit(2);
			}
			strncpy( file , "server.conf" , 255 );
			fclose( fd );
			port[ strlen(port) - 1 ] = '\0';
			path[ strlen(path) - 1 ] = '\0';
			chdir( path );

		} else {
			/* on utilise les paramtres standards */
			strncpy( port , "2222" , 10 );
			strncpy( file , "[default settings]" , 255 );
			getcwd( path , 255 );	
		}
	}
		
	printf("using %s file => port: %s, path: %s...ok.\n",file,port,path);

	printf("server socket created...");
	fflush( stdout );
	fdsock = server_socket( port , "udp" , 5 );
	if( fdsock > 0 )
		printf("ok\n");
	else
		printf("failed");

	nb_connecte = 0 ;
	
	while( 1 ) {
		bzero( &p , sizeof(packet));
		ret_read = -1 ;
		ret_read = my_read( fdsock , &p , sizeof(p) , (struct sockaddr*)&from , &s_from ); 
		
		if( ret_read >= 0 ) {
			switch( p.header ) {
				case CTRL_PACKET :
					{
					if( p.type_packet.control.ordre == CONNECT ) {
					int		pid ;

					id = rand( );
					p.id = id ;
					p.header = CTRL_PACKET; 
					p.type_packet.control.ordre = ACK ;
					p.type_packet.control.gen_num = nb_temp_port++ ;
					getcwd( p.type_packet.control.liste , NB_PACKET_TO_SEND*sizeof(char) );
					sendto( fdsock , &p , sizeof(packet) , 0 , (struct sockaddr *)&from , sizeof( struct sockaddr) );
				
					switch( (pid = fork() )) {
						case -1: 
							perror("lowserver> treat_ctrl_msg> realloc\n");
							exit(2);
						case 0: 
							close( fdsock );
							lowserver( nb_temp_port , (struct sockaddr *)&from );
							exit(0);

						default:
							tab_proc = realloc( tab_proc , (nb_lowserver+1)*sizeof(int) );
							if( tab_proc == NULL ) {
								perror("lowserver> treat_ctrl_msg> realloc\n");
								exit(1);
							}
							tab_proc[nb_lowserver] = pid ;
							nb_lowserver++ ;
					} /*switch*/
			
					}/*if*/
					}
					break ;

				default : printf("undefined command...\nlet's this connection down.\n");
			}/* switch */
		}/* if */
	} /* while */

	/* never reached */
	printf("socket serveur close...ok\n");
	close( fdsock );

return 0 ;
}
