/**
 * server - file server in UDP protocol.
 * 2000-2001 by AUTHORS (see AUTHORS for more informations).
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of the
 * gnu/poker distribution for more details.
 ********************************************************************************
 * utils.c :  usefule function for the handler
 ********************************************************************************
 * dim jan 20 22:16:48 CET 2002 - clucas - first edition
 ********************************************************************************
 */

#include "common.h" 

void remove_pid( int *tab , int pid , int nb)
{
	int		*temp ;
	int		i ;

	if( nb - 1 != 0 ) {
		temp = (int *)malloc( (nb-1)*sizeof(int) );
		if( temp == NULL ) {
			perror("server> remove_pid> malloc");
			exit(1);
		}
		
		for( i=0 ; i<nb ; i++ ) {
			if( tab[i] != pid ) {
				temp[i] = tab[i] ;
			}
		}
		free( tab );
		tab = temp ;
	} else {
		tab = NULL ;
	}
}

/**
 * file_exist:
 * have for goal to test if the file in parameter exist.
 * And if exist to return the size of the file
 * parameter(s):
 * o	char *: name of the file
 * return:
 * o -1 or sizeof file
 */
int file_exist( char *file )
{
	extern int		errno;
	int			retval;
	struct stat		st_file ;

	retval = stat( file , &st_file );
	if( retval == -1 ){
		if( errno == ENOENT ) {
			return -1 ;
		} else {
			printf("problme avec le fichier %s!!\n",file);
		}
	} else { return st_file.st_size ; }
}
